grammar org.artop.artext.ecuc.Ecuc with org.artop.artext.Base

import 'platform:/resource/org.artop.artext/model/Base.ecore' as base

generate ecuc "http://www.artop.org/artext/ecuc/Ecuc"

TPackage:
	{TPackage}
	'package' name=QualifiedName  
	(importDeclaration=TImportDeclaration)?
	(elements += TElement)* 
; 

TElement returns base::TElement:
	TEcucModule
;

TEcucModule:
	'module' linkToDefinition=QualifiedName name=ID '{'
		(values+=TEcucParam)*
	'}'; 

TEcucParam:
	definition=ID value=TEcucValue
;

TEcucInstance:
	TEcucModule | TEcucParam
;

TEcucValue:
	TEcucContainerValue | TEcucParamValue | TEcucReferenceValue 
;

TEcucContainerValue:
	{TEcucContainerValue}
	  (name=ID)? '{'
		(values+=TEcucParam)*
	'}'
;

TEcucParamValue:
	TEcucBoolValue | TEcucIntValue | TEcucStringValue | TEcucEnumValue  | TEcucFloatValue
;

TEcucBoolValue:
	 '=' value=BOOLEAN
;

TEcucIntValue:
	 '=' value=(INT | OCT | HEX)
;

TEcucStringValue:
	 '=' value=STRING
;

TEcucEnumValue:
	 '=' ':'value=ID
;

TEcucFloatValue:
	 '=' value=DOUBLE
;

TEcucReferenceValue:
	 '=' value=QualifiedName
;